#!/usr/bin/perl 

use DBI;
use strict;
use Data::Dumper;
use utf8;
use Encode;
use CGI;
use XML::RSS;
use Time::Local;

our $mydb = "/home/path/to/mixirss/diary.db";

#   test param
my $debug = -1 ;
#my $debug = 0 ;

my $hDB;
my $envph;
my $retval;
my @ref;
my $timestump;
my $rssdate ;
my $rsstitle;
my $gmt;
#初期化
my $rss = new XML::RSS (version => '1.0');
print "Content-type: application/rdf+xml\n\n";

#DBread
 $hDB = DBI->connect(
  "dbi:SQLite:dbname=$mydb","","",{PrintError=>0}
  );
if(!$hDB){
	print "$DBI::errstr \n";
	exit;
}
$envph = $hDB->prepare("SELECT id,ownerid,name,title ,link ,time ,description,dataadded FROM diary ORDER by dataadded DESC LIMIT 30");
$retval = $envph->execute();
	if(!$retval){
		print $hDB->errstr . "\n";
		#exit;
	}
while (@ref =  $envph->fetchrow_array ){
# @ref = decode("utf8", @ref);

#print Dumper (\@ref);


	if ($debug == 0){
		print ( "$ref[0],$ref[1],$ref[2],$ref[3],$ref[4],$ref[5],$ref[6],$ref[7]\n");
	}
# JST -> GMT
$gmt =  &to_sec($ref[7]);
	if ($debug == 0){
		print ( "$gmt\n");
	}
$gmt = $gmt - 60*60*9;
	if ($debug == 0){
		print ( "$gmt\n");
	}
$gmt = &to_date($gmt);
	if ($debug == 0){
		print ( "$gmt\n");
	}

	$rsstitle = "$ref[3] / $ref[2]";
		#RSS追加
		$rss->add_item(
		 title       => decode("utf8", $rsstitle ),
		 link        => decode("utf8", $ref[4]),
		 description => decode("utf8", $ref[6]),
		 dc => {
#			date  =>decode("utf8", $ref[5]),
			date  =>decode("utf8", $gmt),
			creator  => decode("utf8", $ref[2]),
   			},
	);

}#end while


# 最終更新日取得
$envph = $hDB->prepare("SELECT time FROM diary ORDER by time DESC LIMIT 1");
$retval = $envph->execute();
	if(!$retval){
		print $hDB->errstr . "\n";
		#exit;
	}
while (@ref = $envph->fetchrow_array ){
#print Dumper (\@ref);
	if ($debug == 0){
		print ( "$ref[0]\n");
	}
		$timestump = $ref[0];
}#end while


#build RSS
 $rss->channel(
   title        => "mixi diary rss",
   link         => "http://mixi.jp/new_friend_diary.pl",
   description  => "マイミクシィ最新日記",
   dc => {
     date       => "$timestump+09:00",
     subject    => "マイミクシィ最新日記",
     creator    => 'sorshi@dcc-jpl.com',
     publisher  => 'sorshi@dcc-jpl.com',
     rights     => 'Copyright 2009, DCC-JPL Japan',
     language   => 'ja',
   },
   syn => {
     updatePeriod     => "hourly",
     updateFrequency  => "1",
     updateBase       => "1901-01-01T00:00+00:00",
   },
 );
 $rss->add_module(prefix=>'my', uri=>'http://purl.org/my/rss/module/');



#rdfファイル書き込み
$rssdate = $rss->as_string;
$rssdate =  encode("utf8", $rssdate);
	if ($debug == 0){
	}else{
	print  "$rssdate\n";
}
	exit ;


# http://hodade.adam.ne.jp/itmemo/index.php?Perl%2F%C6%FC%BB%FE%A4%AB%A4%E9%C9%C3%A4%D8%A4%CE%CA%D1%B4%B9
# を参考に
sub to_sec {
    my($date) = @_;
    my($year,$mon,$day, $hour, $min, $sec) =
        ($date =~ /(\d{4})-(\d\d)-(\d\d) (\d\d):(\d\d):(\d\d)/);
    return timelocal($sec,$min,$hour,$day,$mon-1,$year);
}

sub to_date {
    my($t) = @_;
    my($sec,$min,$hour,$day,$mon,$year,$wday) = localtime($t);
    return sprintf("%04d/%02d/%02d %02d:%02d:%02d",
        $year+1900,$mon+1,$day, $hour, $min, $sec);
}



