#!/usr/bin/perl 

use WWW::Mixi::Scraper;
#use strict;
use utf8;
use Encode;
#use Data::Dumper;
use XML::RSS;
use LWP::Simple;
use File::Basename;
use File::Path;
use DBI;

# ログイン情報
my $mixi_email = 'yourmiximail@example.com'; # メールアドレス
my $mixi_password = 'yourmixipassword'; # パスワード
# 各種設定
our $img_dir = "/home/path/public_html/cgi/mixirss/mirror/";
our $replaceurl = "http://www.example.com/url/to/cgi/mixirss/mirror/";
our $mydb = "/home/path/to/mixirss/diary.db";
my $debug = -1 ;
#my $eucjp = find_encoding('eucjp');
#my $rssfile = "/home/jplcom/public_html/tmp/protect/cgi/mixirss/diary.rdf";

#DB初期化
unless (-e "$mydb"){
if ($debug == 0){
	print "File not exist:$mydb\nCreate DB.\n";
}
	&initdb;
}
my $mixi = WWW::Mixi::Scraper->new(
      email => $mixi_email, password => $mixi_password ,
      mode  => 'HTML'
);
my @list =  $mixi->new_friend_diary->parse;
my $diary = "";

my $timestump = `date  +%Y-%m-%dT%H:%M:%S`; chomp($timestump);
my $description = "";
my $title = "";
my $thumurl = "";
my $mixidescription = "";
my $imageserver = "";
my $now = `date "+%Y-%m-%d %H:%M:%S"`; chomp($now);
my $id = "";
my $owner_id = "";
my $link = "";

#ヘッダ設定
 my $rss = new XML::RSS (version => '1.0');

 $rss->channel(
   title        => "mixi diary rss",
   link         => "http://mixi.jp/new_friend_diary.pl",
   description  => "マイミクシィ最新日記",
   dc => {
     date       => "$timestump+09:00",
     subject    => "マイミクシィ最新日記",
     creator    => 'sorshi@dcc-jpl.com',
     publisher  => 'sorshi@dcc-jpl.com',
     rights     => 'Copyright 2009, DCC-JPL Japan',
     language   => 'ja',
   },
   syn => {
     updatePeriod     => "hourly",
     updateFrequency  => "1",
     updateBase       => "1901-01-01T00:00+00:00",
   },
 );

 $rss->add_module(prefix=>'my', uri=>'http://purl.org/my/rss/module/');

# ここをループ
#-------------------------------------------------------
foreach $item (@list){
#for ($j= 0; $j< 3; $j++){
#$item = $list[$j];
$link = $item->{'link'} ;

if ($link ne ""){
if(&isthisnewdiary("$link")){
	if ($debug == 0){
		print  encode("utf8", "Diary exist;ski@:$link \n");
	}
}else{
$diary = $mixi->parse($item->{'link'});

$description = "";
$title = "$diary->{'subject'} / $item->{'name'}"; # タイトル / 作者

#写真ミラー&挿入
for ($i=0;$i<3;$i++){
if ($diary->{'images'}[$i]{'thumb_link'} ne ""){
	get_mirror($diary->{'images'}[$i]{'thumb_link'});
		$thumurl = $diary->{'images'}[$i]{'thumb_link'};
		$thumurl =~ s|http://|$replaceurl|;
	$description .= "<a href=\"$diary->{'images'}[$i]{'link'}\"><img src=\"$thumurl\"></a>";
}#if
}#for

#本文画像ミラー処理
$mixidescription = $diary->{'description'};
while($mixidescription =~ m|http://ic.*?.mixi.jp/.*?\.jpg|){
	$mixidescription =~ m|http://ic.*?.mixi.jp/.*?\.jpg|;
	get_mirror($&);
	$imageserver = $& ;
	$imageserver =~ m/ic.*?.mixi.jp/;
	$imageserver = $& ;
	$mixidescription =~ s|http://ic.*?.mixi.jp|${replaceurl}$imageserver|;
}
$description .= $mixidescription;

if ($debug == 0){
print  encode("utf8", $item->{'link'});
print "\n";
print  encode("utf8", $item->{'name'});
print "\n";
print  encode("utf8", $item->{'time'});
print "\n";
print  encode("utf8", $item->{'subject'});
print "\n";
print  encode("utf8", $diary->{'level'}->{'description'});
print "\n";
print  encode("utf8", $diary->{'subject'});
print "\n";
print  encode("utf8", $description);
print "\n";
}

#SQLite追加
$link = $item->{'link'} ;
($id,$owner_id) = &getids("$link");
if ($debug == 0){
	print  encode("utf8", "IDs : $id,$owner_id\n");
}
$now = `date "+%Y-%m-%d %H:%M:%S"`;chomp($now);
&sqlitedbadd("$id","$owner_id",$diary->{'subject'},$item->{'link'},"$description",$item->{'time'},$item->{'name'},"$now");

#RSS追加
	$rss->add_item(
		 title       => $title ,
		 link        => $item->{'link'},
		 description =>  $description,
		 dc => {
			date  =>$item->{'time'},
			creator  => $item->{'name'},
   			},
	);
}#endif isthisnewdiary("$link"
}#end if  $item->{'link'} ne ""
}# end foreach
#-------------------------------------------------------

$rss->add_item (title=>$title, link=>$link, slash=>{ topic=>$topic });

#rdfファイル書き込み
my $rssdate ;
$rssdate = $rss->as_string;
#Jcode::convert(\$rssdate, 'utf8');
$rssdate =  encode("utf8", $rssdate);
#open(RSS,"> $rssfile") || die "File Cannot create!";
#print RSS "$rssdate";
#close (RSS);
#

sub get_mirror{
    my $url = shift;
	my $localfile = $url;
	my $base_name;
	my $dir;
	
	$localfile =~ s|http://|$img_dir|;
	#ファイルが既にあるか見る
	if(-e $localfile){
	#print "exist\n";
	}else{
	#なければ
	#print "DL\n";
	( $base_name, $dir ) = fileparse( $localfile );
		if (-d $dir){
		}else{
		mkpath($dir);
		}
	#げっと
	getstore($url,$localfile);
	}
#print "$base_name \n$dir \n$url \n$localfile\n";
}#end sub get_mirror




sub sqlitedbadd{
my $id = $_[0];
my $owner_id = $_[1];
my $title = $_[2];
my $link = $_[3];
my $description = $_[4];
my $time = $_[5];
my $name = $_[6];
my $dataadded = $_[7];
my $hst;
my $hDB;
my $retval;

if ($debug == 0){
	print  encode("utf8", "SQLite INSERT: $id ; $owner_id ; $title; $link; $description; $time; $name; $dataadded  \n");
}

$hDB = DBI->connect(
  "dbi:SQLite:dbname=$mydb","","",{PrintError=>0}
  );
if(!$hDB){
	print "$DBI::errstr \n";
	exit;
}

$hst = $hDB->prepare( "INSERT INTO diary VALUES(?,?,?,?,?,?,?,?)" ) or die "Cannot prepare:$!";
if($hst){
	$retval = $hst->execute($id,$owner_id , $title, $link , $description , $time , $name , $dataadded );
	if(!$retval){
		print $hDB->errstr . "\n";
		#exit;
	}
}else{
	# エラー処理
	print $hDB->errstr . "\n";
#	exit;
}#end if
}#endsub sqlitedbadd

sub getids($link){
use URI;
my $uri = URI->new($link);
if ($debug == 0){
	print  encode("utf8", $link ."\n");
	print  encode("utf8", $uri->query ."\n");
}
#print $uri->query . "\n";
my @param = "";
@param = split(/&/,$uri->query);
#print Dumper (\@param);
my @ids = "";
@ids = split(/=/,$param[0]);
my $id = $ids[1];
@ids = split(/=/,$param[1]);
my $owner_id = $ids[1];
#print "$link\n";
if ($debug == 0){
	print  encode("utf8", "$id,$owner_id \n");
}
return ($id,$owner_id)
}#endsub getids



sub isthisnewdiary($link){
my $hDB ;
my $sql = "";
my $id;
my $owner_id;
my $envph;
my @ref;
my $retval;

if ($link ne ""){
($id , $owner_id ) = &getids("$link");

 $hDB = DBI->connect(
  "dbi:SQLite:dbname=$mydb","","",{PrintError=>0}
  );

if(!$hDB){
	print "$DBI::errstr \n";
	exit;
}

$envph = $hDB->prepare("SELECT name,title ,link ,time ,dataadded FROM diary  WHERE id = ? AND ownerid = ?");
$retval = $envph->execute($id,$owner_id);
	if(!$retval){
		print $hDB->errstr . "\n";
		#exit;
	}
while (@ref = $envph->fetchrow_array ){
#print Dumper (\@ref);
	if ($debug == 0){
		print ( "$ref[0],$ref[0],$ref[1],$ref[2],$ref[3],$ref[4]\n");
	}
}#end while
  if ($envph->rows == 0) {
	return (0);
  }else{
	return (-1);
  }
}#end if
}#end sub isthisnewdiary


sub initdb(){
my $hst;
my $hDB;

unless (-e "$mydb"){
	open DB, ">>$mydb" || die $!;
	close DB;
$hDB = DBI->connect(
  "dbi:SQLite:dbname=$mydb","","",{PrintError=>0}
  );
if(!$hDB){
	print "$DBI::errstr \n";
	exit;
}
my $sql = "
create table diary (
id int8 PRIMARY KEY ,
ownerid int8,
title text,
link text,
description text,
time DATETIME,
name text,
dataadded DATETIME
);
";
$hst = $hDB->do($sql);
if(!$hst){
	print $hDB->errstr . "\n";
	exit;
}
}#unless
}# end sub 
























